macroScript Vray_AO category:"dPict Tools" tooltip:"Vray Ambient Occlusion"
(
--Vray Ambient Occlusion
--version 2.0
--works with Vray 1.5 or higher, max 5 or higher
--by Marc Lorenz
--http://plugins.angstraum.at

--Modified: Version 3.2DP
--by David Parisi
--Added: Additional Dirtmap Options (Dist, Falloff, Z Bias), Image sampler overrides, Environment Color Override, Displacement option, Camera Exposure option, VrayAmbient Light,  
--		Skylight with Dirtmap, Light Multiplier, Material Override Option, Reflect/Refract Option, Render Last Option, Disable Vray Frame Buffer filesaving
--http://www.dpict3d.com


--version checking
err=undefined
if findString (vray() as string) "VRay_Adv_1_0" != undefined then err="Sorry this script only works with Vray 1.5 or higher."
if findString (vray() as string) "VRay_Adv_1_45" != undefined then err="Sorry this script only works with Vray 1.5 or higher."
if findString (vray() as string) "VRay_Adv_1_46" != undefined then err="Sorry this script only works with Vray 1.5 or higher."
if findString (vray() as string) "VRay_Adv_1_47" != undefined then err="Sorry this script only works with Vray 1.5 or higher."
if findString (vray() as string) "VRay_Adv_1_48" != undefined then err="Sorry this script only works with Vray 1.5 or higher."
if findString (vray() as string) "VRay_Adv_1_49" != undefined then err="Sorry this script only works with Vray 1.5 or higher."


global ml_dirtmaterial

fn isLoadedVray targetslot assign:false=
	(
	
	try
	(
	if (targetslot==1) then slot=renderers.production
	else slot=renderers.draft
	)
	catch()
	
	--is vray even installed?
	a=(findItem RendererClass.classes vray)
	if (a!=0) then
		(
		--detect if ANY VRay version is active
		if (findString (slot as string) "VRay"!=undefined) or (findString (slot as string) "V_Ray"!=undefined) then return true
		else
			(
			if assign then 
				(
				if (queryBox "VRay is not the active renderer.   \nLoad it and proceed?" title:"Warning") then
					(
					--store current
					--dumb maxscript can only assign to currently avtive renderer slots
					b=renderer
					case targetslot of
						(
						1:	(
							renderer=#production
							renderers.production=RendererClass.classes[a]()
							)
						2:	(
							renderer=#draft
							renderers.draft=RendererClass.classes[a]()
							)
						)
					--reassign current
					renderer=b
					return true
					)
				)
			)
		)
	return false
	)
if (isLoadedVray 1)==false then err="VRay doesn't appear to be active. Please assign it as the current renderer."

if err != undefined then messageBox err title:"Error"
else

(

--detect light/dark ui for icons and hyperlink
local hyperlink_color, ui_color
if (colorMan.getColor #text).x < 0.2 then 
	(
	ui_color=3
	hyperlink_color=(color 8 8 136)
	)
else
	(
	ui_color=1
	hyperlink_color=white
	)


global ro_vrayao

rollout ro_vrayao "Vray ambient occlusion 3.2" width:312 height:343
(
	label lbl6 "Original:" pos:[14,10] width:38 height:19 enabled:true
	HyperLink link1 "plugins.angstraum.at" pos:[56,10] width:103 height:15 address:"http://plugins.angstraum.at"
	label lbl2 "modified:dlparisi" pos:[221,10] width:138 height:25 enabled:true
	GroupBox grp25 "Method" pos:[8,31] width:296 height:54
	radiobuttons option_method "" pos:[24,49] width:260 height:16 labels:#("Dirtmap", "Skylight", "Ambient Light") default:3 columns:3
	checkbox chk_useDirt "w/ dirtmap" pos:[120,64] width:94 height:17 enabled:false
	GroupBox grp_dirt "Dirtmap Options" pos:[8,87] width:144 height:104
	spinner spn_dirtradius "Radius:" pos:[41,108] width:100 height:16 range:[0,100000,120] type:#worldunits 
	spinner spn_dirtdist "Distrib:" pos:[50,128] width:63 height:16 range:[0,100000,1] type:#float 
	spinner spn_dirtfalloff "Falloff:" pos:[50,148] width:63 height:16 range:[0,100000,0] type:#float 
	spinner spn_Zbias "Z Bias:" pos:[50,169] width:63 height:16 range:[-10,10,0] type:#float
	GroupBox grp_sky "Skylight/Ambient Light" pos:[159,87] width:145 height:62 enabled:true
	radiobuttons rdo_skytype "" pos:[168,107] width:142 height:16 enabled:false labels:#("Sphere   ", "Dome") columns:2
	spinner spn_mult "Multiplier" pos:[194,127] width:79 height:16 range:[0,100,1]
	GroupBox grp_mat "Global Options" pos:[159,151] width:145 height:113 enabled:true
	spinner spn_subdivs "Subdivs: " pos:[197,168] width:85 height:16 range:[1,1000,16] type:#integer
	checkbox mat_ovr "Override Materials" pos:[171,185] width:115 height:21 enabled:true checked:true
	checkbox ref_ovr "Reflect/Refract" pos:[171,205] width:115 height:21 enabled:false checked:true
	checkbox disp_ovr "Displacement" pos:[171,225] width:90 height:19 checked:false
	checkbox expOn "Camera Exposure" pos:[171,243] width:110 height:19 enabled:true checked:false
	GroupBox grp_env "Background Override" pos:[8,192] width:144 height:72
	colorPicker ovr_color "" pos:[14,215] width:54 height:42 enabled:true color:(color 255 255 255)
	checkbox env_ovr "Enable" pos:[75,214] width:54 height:19 enabled:true checked:true
	checkbox chk_mlm "Use light multiplier" pos:[75,231] width:73 height:31 enabled:true checked:true
	GroupBox grp2 "Image Sampler Override" pos:[8,266] width:296 height:38
	radiobuttons sampler_override "" pos:[19,283] width:296 height:16 labels:#("No Change", "Adapt. DMC", "Adapt. Subd.") columns:3
	button btn_render "Render Last" pos:[93,315] width:125 height:21
	checkbox chk_renderlast "Render last" pos:[223,316] width:72 height:20 checked:true
		
		
	on ro_vrayao open do
	(
	link1.color=hyperlink_color
	link1.hovercolor=hyperlink_color
	link1.visitedcolor=hyperlink_color
	)
	
	on chk_renderlast changed state do
		if chk_renderlast.checked==true then btn_render.caption="Render Last" else btn_render.caption="Render Current"

	on option_method changed state do
	(
			case option_method.state of
				(
				1:(grp_sky.enabled=false
					grp_dirt.enabled=true
					spn_dirtradius.enabled=true
					spn_dirtdist.enabled=true
					spn_dirtfalloff.enabled=true
					spn_Zbias.enabled=true
					rdo_skytype.enabled=false
					spn_mult.enabled=false
					chk_mlm.enabled=false
					mat_ovr.enabled=false
					ref_ovr.enabled=false
					chk_useDirt.enabled=false)
				2:( if chk_useDirt.checked==true then
						(
						grp_dirt.enabled=true
						spn_dirtdist.enabled=true
						spn_dirtfalloff.enabled=true
						spn_dirtradius.enabled=true
						spn_Zbias.enabled=true
						mat_ovr.enabled=false
						ref_ovr.enabled=false
						)else
						(
						grp_dirt.enabled=false
						spn_dirtdist.enabled=false
						spn_dirtfalloff.enabled=false
						spn_dirtradius.enabled=false
						spn_Zbias.enabled=false
						mat_ovr.enabled=true
						if mat_ovr.checked==true then ref_ovr.enabled=false else ref_ovr.enabled=true
						)
					grp_sky.enabled=true
					rdo_skytype.enabled=true
					spn_mult.enabled=true
					if env_ovr.checked==true then chk_mlm.enabled=true else chk_mlm.enabled=false
					chk_useDirt.enabled=true)
				3:(grp_dirt.enabled=true
					grp_sky.enabled=true
					spn_dirtradius.enabled=true
					rdo_skytype.enabled=false
					spn_dirtdist.enabled=true
					spn_dirtfalloff.enabled=true
					spn_Zbias.enabled=true
					spn_mult.enabled=true
					if env_ovr.checked==true then chk_mlm.enabled=true else chk_mlm.enabled=false
					mat_ovr.enabled=true
					if mat_ovr.checked==false then ref_ovr.enabled=true else ref_ovr.enabled=false
					chk_useDirt.enabled=false)
	
			)
		)
		
	on chk_useDirt changed state do
	(
			if chk_useDirt.checked==true then
			(
			grp_dirt.enabled=true
			spn_dirtdist.enabled=true
			spn_dirtfalloff.enabled=true
			spn_dirtradius.enabled=true
			spn_Zbias.enabled=true
			mat_ovr.enabled=false
			ref_ovr.enabled=false
			)else
			(
			grp_dirt.enabled=false
			spn_dirtdist.enabled=false
			spn_dirtfalloff.enabled=false
			spn_dirtradius.enabled=false
			spn_Zbias.enabled=false
			mat_ovr.enabled=true
			if mat_ovr.checked==true then ref_ovr.enabled=false else ref_ovr.enabled=true
			)
		)
	on mat_ovr changed state do
		(if mat_ovr.checked==true then ref_ovr.enabled=false else ref_ovr.enabled=true)
	on env_ovr changed state do
		(if option_method.state!=1 then chk_mlm.enabled=env_ovr.checked)
	on btn_render pressed do
	(
	
	local hcoverride=#()
	
	append hcoverride "gi_on=false"
	append hcoverride "colorMapping_darkMult=1"
	append hcoverride "colorMapping_brightMult=1"
	append hcoverride "options_hiddenLights=false"
	append hcoverride "options_defaultLights=false"		

	--image sampler overrides
	If disp_ovr.checked==false then
		(
		append hcoverride "options_displacement=false"
		)
		else
		(
		append hcoverride "options_displacement=true"
	)
		
	if sampler_override.state==2 then
		(
		--optimial AA QMC settings
		append hcoverride "imageSampler_type=1"
		append hcoverride "twoLevel_useDMCSamplerThresh=true"
		append hcoverride "dmc_earlyTermination_amount=0.85"
		append hcoverride "dmc_earlyTermination_threshold=0.001"		
	)
	if sampler_override.state==3 then
		(
		--Adaptive Subdivison settings
		append hcoverride "imageSampler_type=2"
		append hcoverride "adaptiveSubdivision_minRate=-1"
		append hcoverride "adaptiveSubdivision_maxRate=2"
		append hcoverride "adaptiveSubdivision_threshold=0.1"
	)
	
	--use "override material" for skylight and ambient
	if ((option_method.state==2 and mat_ovr.checked==false and chk_useDirt.checked!=true) or (option_method.state==3 and mat_ovr.checked==false))  then (append hcoverride "options_overrideMtl_on=false") else (append hcoverride "options_overrideMtl_on=true")
	
	--get orig backgrond params
	dp_environColor=backgroundColor
	dp_environMap=getUseEnvironmentMap() 
	
	--backgroundcolor
	if env_ovr.checked==true then
		(
		if ((option_method.state!=1) and chk_mlm.checked==true) then backgroundColor=ovr_color.color*spn_mult.value else backgroundColor=ovr_color.color
		useEnvironmentMap=off
	)
	
	--enable/disable reflect/refract
	if ref_ovr.checked==false then (append hcoverride "options_reflectionRefraction=false") else (append hcoverride "options_reflectionRefraction=true")
	
	--Ambient or skylight
	if option_method.state!=1 then 
		(
		if mat_ovr.checked==true then append hcoverride "options_overrideMtl_mtl=VRayMtl diffuse:(color 255 255 255)"
		ml_dirtmaterial=VRayMtl()
		ml_dirtmaterial.diffuse=(color 255 255 255)
		ml_dirtmaterial.texmap_diffuse=VRayDirt()
		ml_dirtmaterial.texmap_diffuse.radius=spn_dirtradius.value
		ml_dirtmaterial.texmap_diffuse.falloff=spn_dirtfalloff.value
		ml_dirtmaterial.texmap_diffuse.subdivs=spn_subdivs.value
		ml_dirtmaterial.texmap_diffuse.distribution=spn_dirtdist.value
		ml_dirtmaterial.texmap_diffuse.bias=[0,0,spn_Zbias.value]
		ml_dirtmaterial.texmap_diffuse.texmap_unoccluded_color = VRayColor ()
		ml_dirtmaterial.texmap_diffuse.texmap_unoccluded_color.color=(color 255 255 255)
		ml_dirtmaterial.texmap_diffuse.texmap_unoccluded_color.rgb_multiplier = spn_mult.value
		if option_method.state==2 and chk_useDirt.checked==true then (append hcoverride "options_overrideMtl_mtl=ml_dirtmaterial")
	)
	
	--dirtmap
	if option_method.state==1 then 
		(
		ml_dirtmaterial=VRayLightMtl()
		ml_dirtmaterial.color=(color 255 255 255)
		ml_dirtmaterial.texmap=VRayDirt()
		ml_dirtmaterial.texmap.radius=spn_dirtradius.value
		ml_dirtmaterial.texmap.falloff=spn_dirtfalloff.value
		ml_dirtmaterial.texmap.subdivs=spn_subdivs.value
		ml_dirtmaterial.texmap.bias=[0,0,spn_Zbias.value]
		ml_dirtmaterial.texmap.distribution=spn_dirtdist.value
		append hcoverride "options_overrideMtl_mtl=ml_dirtmaterial"	
	)
	
	
	disableSceneRedraw()
	
	--get vray frame buffer save status
		dp_current_output_save=getProperty renderers.current #output_saveRawFile
		dp_current_output_splitgbuffer=getProperty renderers.current #output_splitgbuffer
		dp_current_output_splitgname=getProperty renderers.current #output_splitfilename
		print dp_current_output_splitgname
	
	--turn off vrayframe buffer save
		setProperty renderers.current #output_saveRawFile false
		setProperty renderers.current #output_splitgbuffer false
	
	--snapshot of current vray settings
	current_snapshot=#()
	for i in (getpropnames vray) do
		(
		try 
		(
		val=getProperty renderers.current i
		if (classOf val)==String then val="\""+val+"\""
		append current_snapshot ( (i as string)+"="+(val as string))
		)
		catch()
		)
		
	--get current override material
		dp_current_override_mtl=getProperty renderers.current #options_overrideMtl_mtl
		
	--apply overrides
	for i in hcoverride do
		(
		try execute ("renderers.current."+i)
		catch()
		)
	
	--detect active lights to disable
	ml_activelights=#()
	for i in lights do
		(
		try if i.on then append ml_activelights i
		catch()
		try if i.enabled then append ml_activelights i
		catch()
		)
	
	for i in ml_activelights do 
		(
		try i.on=false
		catch()
		try i.enabled=false
		catch()
		)
		
	--detect physical camera exposure and vignetting and disable
	dp_camsExp = #()
	dp_camsVig = #()
	
	for i in cameras do 
		(
		if (hasProperty i "exposure")==true then 
				(
				if i.exposure==on then append dp_camsExp i
				if i.vignetting==on then append dp_camsVig i
				)
		)
	
	for i in dp_camsExp do 
		(i.exposure=off)
	
	for i in dp_camsVig do 
		(i.vignetting=off)
		
	
	--start rendering
	
	if option_method.state==2 then (
			if rdo_skytype.state==2 then
				(
				--dome
				ml_dome=VRayLight dome_spherical:off size0:0 size1:0 type:1 multiplier:spn_mult.value on:on invisible:on affect_specular:off affect_reflections:off subdivs:spn_subdivs.value
				if chk_renderlast.checked==true then (max render last) else (max quick render)
				delete ml_dome
			)
			else
				(
				--sphere
				ml_dome=VRayLight dome_spherical:on size0:0 size1:0 type:1 multiplier:spn_mult.value on:on invisible:on affect_specular:off affect_reflections:off subdivs:spn_subdivs.value
				if chk_renderlast.checked==true then (max render last) else (max quick render)
				delete ml_dome
			)
	)
	else 
		(
		if option_method.state==3 then 
			(
			--ambient
			dp_ambient=VrayAmbientLight enabled:on intensity:spn_mult.value light_map_on:on compensate_exposure:off light_map:ml_dirtmaterial.texmap_diffuse
			if chk_renderlast.checked==true then (max render last) else (max quick render)
			--max quick render
			delete dp_ambient
			)
			else
			(
			--dirtmap w/VrayLightMtl
			if chk_renderlast.checked==true then (max render last) else (max quick render) 
	
			)
		)
	
	
	--restore original vray settings
	for i in current_snapshot do
		(
		try execute ("renderers.current."+i)
		catch()
		)
	
	--restore override material
	setProperty renderers.current #options_overrideMtl_mtl dp_current_override_mtl 
		
	--restore vray frame buffer status (fixes bad filenames)
	setProperty renderers.current #output_saveRawFile dp_current_output_save
	setProperty renderers.current #output_splitgbuffer dp_current_output_splitgbuffer	
	setProperty renderers.current #output_splitfilename dp_current_output_splitgname	
		
	--restore backgroundsettings
		backgroundColor=dp_environColor
		useEnvironmentMap=dp_environMap
		
	--restore lights
	for i in ml_activelights do
		(
		try i.on=true
		catch()
		try i.enabled=true
		catch()		
		)
	
	--Restore Exposure and Vignetting
	for i in dp_camsExp do 
		(i.exposure=on)
	
	for i in dp_camsVig do 
		(i.vignetting=on)
		enableSceneRedraw()
	
	)
)



Createdialog ro_vrayao 312 343 modal:false --style:#(#style_sysmenu,#style_toolwindow)

)
)
